package org.objectweb.jinha.commands;

import org.objectweb.jinha.model.FinderModel;
import org.objectweb.jinha.model.ListModel;

/**
 * add a finder to a entity bean's list of finders
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class CreateFinderCommand extends MainCommand {

    private ListModel   list;

    private FinderModel newMethod;

    /**
     * @param list the list where will be added the finder
     * @param newMethod the finder to be added
     */
    public CreateFinderCommand(ListModel list, FinderModel newMethod) {
        this.newMethod = newMethod;
        this.list = list;
    }

    /**
     * performs the adding of the finder in the list
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute() {
        list.addElement(newMethod);
    }

    /**
     * performs execute()
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo() {
        execute();
    }

    /**
     * remove the finder of the list
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {
        list.removeElement(newMethod);
    }
}

