package org.objectweb.jinha.commands;

import org.eclipse.draw2d.Bendpoint;
import org.objectweb.jinha.model.RelationModel;

/**
 * delete a bendpoint from a relation
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class DeleteBendpointCommand extends MainCommand {

    private int           index;

    private RelationModel model;

    private Bendpoint     bendpoint;

    /**
     * @param model the relation
     * @param index the index of the bendpoint to be deleted
     */
    public DeleteBendpointCommand(RelationModel model, int index) {
        this.model = model;
        this.index = index;
    }

    /**
     * performs the deletion of the bendpoint from the relation
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute() {
        bendpoint = model.removeBendpoint(index);
    }

    /**
     * same as execute()
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo() {
        model.removeBendpoint(index);
    }

    /**
     * restore the bendpoint to the relation
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {
        model.addBendpoint(bendpoint, index);
    }
}