package org.objectweb.jinha.commands;

import org.objectweb.jinha.model.AttributeModel;
import org.objectweb.jinha.model.BusinessMethodModel;
import org.objectweb.jinha.model.CMPModel;
import org.objectweb.jinha.model.CMRModel;
import org.objectweb.jinha.model.EntityModel;
import org.objectweb.jinha.model.HomeMethodModel;
import org.objectweb.jinha.model.ListModel;
import org.objectweb.jinha.model.RelationModel;
import org.objectweb.jinha.model.emf.jinha.GraphicalEntity;
import org.objectweb.jinha.model.emf.jinha.GraphicalSession;

import com.sun.java.xml.ns.j2ee.EntityBeanType;
import com.sun.java.xml.ns.j2ee.FullyQualifiedClassType;

/**
 * delete an element (method, CMP, CMR..) to an ejb's list
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
 */
public class ListElementDeleteCommand extends MainCommand {

    private Object        child;

    private CMRModel      cmrSource;

    private CMRModel      cmrTarget;

    private EntityModel   entitysource;

    private EntityModel   entityTarget;

    private ListModel     list;

    private int           oldIndex;

    DeleteRelationCommand c                 = null;

    boolean               isDeletedRelation = false;

    /**
     * @param list the list where will be deleted the object
     * @param child the element to be deleted
     */
    public ListElementDeleteCommand(ListModel list, Object child) {
        this.child = child;
        this.list = list;

    }

    /**
     * performs the deletion of the element from the list
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute() {
        oldIndex = list.getIndexOf(child);

        if (child instanceof CMRModel) {

            RelationModel relation = ((CMRModel) child).getRelation();
            entitysource = relation.getSource();
            entityTarget = relation.getTarget();
            if (relation.getCMRsrc() == (CMRModel) child) {
                cmrSource = (CMRModel) child;
                cmrTarget = relation.getCMRtarget();
                if (relation.getCMRtarget() == null) {

                    c = new DeleteRelationCommand(relation);
                    c.execute();
                    isDeletedRelation = true;
                }
                else {
                    list.removeElement(child);
                    isDeletedRelation = false;
                }
            }
            else if (relation.getCMRtarget() == (CMRModel) child) {
                cmrTarget = (CMRModel) child;
                cmrSource = relation.getCMRsrc();
                if (relation.getCMRsrc() == null) {
                    c = new DeleteRelationCommand(relation);
                    c.execute();
                    isDeletedRelation = true;
                }
            }
        }

        else {
            list.removeElement(child);
            if(child instanceof CMPModel && !list.getElementList().isEmpty()){
                ((GraphicalEntity) list.getEjb()).getEntityBean()
                .getFieldMappings().remove(
                        ((CMPModel) child).getFieldMapping());
                
            	((CMPModel)list.getElementList().get(0)).setPrimaryKey(true);

                
                EntityBeanType entityBean=((GraphicalEntity)list.getEjb()).getEntityBean().getEntityEjb();
                ((CMPModel)child).setPrimaryKey(true);
                com.sun.java.xml.ns.j2ee.String primaryKey = j2eeFactory.createString();
        		primaryKey.setValue(((CMPModel)list.getElementList().get(0)).getIdentifier());
        		entityBean.setPrimkeyField(primaryKey);
        		FullyQualifiedClassType primaryKeyClass = j2eeFactory.createFullyQualifiedClassType();
        		primaryKeyClass.setValue(((CMPModel)list.getElementList().get(0)).getReturnType());
        		entityBean.setPrimKeyClass(primaryKeyClass);
            }
            if(child instanceof CMPModel && list.getElementList().isEmpty())
            	list.addElement(child);
                
            if (list.getEjb() instanceof GraphicalSession) {
                if (child instanceof AttributeModel) {
                    //  res.getContents().remove(child);

                    ((GraphicalSession) list.getEjb()).getSessionBean()
                            .getJavaAttributes().remove(
                                    ((AttributeModel) child).getAttribute());
                }
                else if (child instanceof HomeMethodModel)
                    ((GraphicalSession) list.getEjb()).getSessionBean()
                            .getMethods().remove(
                                    ((HomeMethodModel) child).getMethod());
                else if (child instanceof BusinessMethodModel)
                    ((GraphicalSession) list.getEjb()).getSessionBean()
                            .getMethods().remove(
                                    ((BusinessMethodModel) child).getMethod());

            }
             else if (list.getEjb() instanceof GraphicalEntity) {
                if (child instanceof AttributeModel)
                    ((GraphicalEntity) list.getEjb()).getEntityBean()
                            .getJavaAttributes().remove(
                                    ((AttributeModel) child).getAttribute());
                else if (child instanceof HomeMethodModel)
                    ((GraphicalEntity) list.getEjb()).getEntityBean()
                            .getMethods().remove(
                                    ((HomeMethodModel) child).getMethod());
                else if (child instanceof BusinessMethodModel)
                    ((GraphicalEntity) list.getEjb()).getEntityBean()
                            .getMethods().remove(
                                    ((BusinessMethodModel) child).getMethod());

                    

            }
             /*
             else if(list.getEjb() instanceof GraphicalMessageDriven) {
             if(child instanceof AttributeModel)
             ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getJavaAttributes().remove(((AttributeModel)child).getAttribute());
             else if (child instanceof HomeMethodModel)
             ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getMethods().remove(((HomeMethodModel)child).getMethod());
             else if (child instanceof BusinessMethodModel)
             ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getMethods().remove(((BusinessMethodModel)child).getMethod());

             }*/

            isDeletedRelation = false;

        }
    }

    /**
     * same as execute()
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo() {
        execute();

    }

    /**
     * restore the element in the list
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {

        if (child instanceof CMRModel) {
            if (isDeletedRelation == true) {
                CreateRelationCommand command = new CreateRelationCommand(
                        entitysource, entityTarget);
                command.setCMRsrc(cmrSource);
                command.execute();
                isDeletedRelation = false;
            }
        }

        else {
            list.addElement(child);
            if (list.getEjb() instanceof GraphicalSession) {
                if (child instanceof AttributeModel)
                    ((GraphicalSession) list.getEjb()).getSessionBean()
                            .getJavaAttributes().add(
                                    ((AttributeModel) child).getAttribute());
                else if (child instanceof HomeMethodModel)
                    ((GraphicalSession) list.getEjb()).getSessionBean()
                            .getMethods().add(
                                    ((HomeMethodModel) child).getMethod());
                else if (child instanceof BusinessMethodModel)
                    ((GraphicalSession) list.getEjb()).getSessionBean()
                            .getMethods().add(
                                    ((BusinessMethodModel) child).getMethod());

            }
            /* else if(list.getEjb() instanceof GraphicalEntity) {
             if(child instanceof AttributeModel)
             ((GraphicalEntity)list.getEjb()).getEntityBean().getJavaAttributes().add(((AttributeModel)child).getAttribute());
             else if (child instanceof HomeMethodModel)
             ((GraphicalEntity)list.getEjb()).getEntityBean().getMethods().add(((HomeMethodModel)child).getMethod());
             else if (child instanceof BusinessMethodModel)
             ((GraphicalEntity)list.getEjb()).getEntityBean().getMethods().add(((BusinessMethodModel)child).getMethod());

             }
             else if(list.getEjb() instanceof GraphicalMessageDriven) {
             if(child instanceof AttributeModel)
             ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getJavaAttributes().add(((AttributeModel)child).getAttribute());
             else if (child instanceof HomeMethodModel)
             ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getMethods().add(((HomeMethodModel)child).getMethod());
             else if (child instanceof BusinessMethodModel)
             ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getMethods().add(((BusinessMethodModel)child).getMethod());

             }*/
        }
    }
}