package org.objectweb.jinha.commands;

import org.objectweb.jinha.model.EntityModel;
import org.objectweb.jinha.model.RelationModel;

/**
 * reconnect a relation to a new ejb source 
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class ReconnectSourceCommand extends MainCommand {

    private EntityModel   newSource;

    private EntityModel   oldSource;

    private RelationModel connection;

    /**
     * @param newSource the new ejb source
     * @param connection the relation
     */
    public ReconnectSourceCommand(EntityModel newSource,
            RelationModel connection) {
        this.newSource = newSource;
        this.connection = connection;
    }

    /**
     * performs the change of ejb source
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute() {
        oldSource = connection.getSource();
        connection.setSource(newSource);
    }

    /**
     * same as execute()
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo() {
        connection.setSource(newSource);
    }

    /**
     * restore the old source to the relation
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {
        connection.setSource(oldSource);
    }
}