package org.objectweb.jinha.editor;
 
import org.eclipse.gef.ContextMenuProvider;
import org.eclipse.gef.GraphicalViewer;
import org.eclipse.gef.ui.actions.ActionRegistry;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.ui.IWorkbenchActionConstants;
import org.objectweb.jinha.actions.CreateAttributeAction;
import org.objectweb.jinha.actions.CreateBusinessMethodAction;
import org.objectweb.jinha.actions.CreateCMPAction;
import org.objectweb.jinha.actions.CreateFinderAction;
import org.objectweb.jinha.actions.CreateHomeMethodAction;

/**
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 */
public class ContextMenuProviderImpl extends ContextMenuProvider {

    private ActionRegistry actionRegistry;

    /**
     * @param ar
     *            the action registry that contains actions available int the
     *            Graphical Viewer
     * @param gv
     *            the graphical Viewer for JINHa
     */

    public ContextMenuProviderImpl(ActionRegistry ar, GraphicalViewer gv) {
        super(gv);
        actionRegistry = ar;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.gef.ContextMenuProvider#buildContextMenu(org.eclipse.jface.action.IMenuManager)
     */
    public void buildContextMenu(IMenuManager manager) {
        GEFActionConstants.addStandardActionGroups(manager);

        IAction action;

        action = actionRegistry.getAction(CreateAttributeAction.ID);
        if (action.isEnabled())
            manager.appendToGroup(GEFActionConstants.GROUP_REST, action);

        action = actionRegistry.getAction(CreateBusinessMethodAction.ID);
        if (action.isEnabled())
            manager.appendToGroup(GEFActionConstants.GROUP_REST, action);

        action = actionRegistry.getAction(CreateHomeMethodAction.ID);
        if (action.isEnabled())
            manager.appendToGroup(GEFActionConstants.GROUP_REST, action);

        action = actionRegistry.getAction(CreateCMPAction.ID);
        if (action.isEnabled())
            manager.appendToGroup(GEFActionConstants.GROUP_REST, action);



        action = actionRegistry.getAction(CreateFinderAction.ID);
        if (action.isEnabled())
            manager.appendToGroup(GEFActionConstants.GROUP_REST, action);

        action = actionRegistry.getAction(IWorkbenchActionConstants.DELETE);
        if (action.isEnabled())
            manager.appendToGroup(GEFActionConstants.GROUP_EDIT, action);

        action = actionRegistry.getAction(GEFActionConstants.UNDO);
        manager.appendToGroup(GEFActionConstants.GROUP_UNDO, action);

        action = actionRegistry.getAction(GEFActionConstants.REDO);
        manager.appendToGroup(GEFActionConstants.GROUP_UNDO, action);
    }

}