package org.objectweb.jinha.editparts;
 
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.objectweb.jinha.figures.AttributeListFigure;
import org.objectweb.jinha.model.AttributeListModel;

/**
 *  the editpart for an attribute list
 * catch event from the model and eventually represent it to the figure
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class AttributeListEditPart extends ListEditPart {

    
    /**
     * @return the figure for an attribute list
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    public IFigure createFigure() {
        return new AttributeListFigure();
    }

    
    /**
     * @return the list of children for an attribute list
     * @see org.eclipse.gef.editparts.AbstractEditPart#getModelChildren()
     */
    public List getModelChildren() {
        return ((AttributeListModel) getModel()).getElementList();
    }

}