package org.objectweb.jinha.editparts;
 
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.objectweb.jinha.figures.CMPListFigure;
import org.objectweb.jinha.model.CMPListModel;

/**
 *  the editpart for a CMP list
 * catch event from the model and eventually represent it to the figure
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class CMPListEditPart extends ListEditPart {

    /**
     * @return ths figure associated to a CMP list
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    public IFigure createFigure() {
        return new CMPListFigure();
    }

    /**
     * @return ths lsit of children for this part
     * @see org.eclipse.gef.editparts.AbstractEditPart#getModelChildren()
     */
    public List getModelChildren() {
        return ((CMPListModel) getModel()).getElementList();
    }
}