package org.objectweb.jinha.editparts;
 
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.objectweb.jinha.model.ObjectModel;


/**
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public abstract class ObjectEditPart extends AbstractGraphicalEditPart
        implements PropertyChangeListener {

    
    /**
     * 
     * @see org.eclipse.gef.EditPart#activate()
     */
    public void activate() {
        if (!isActive()) {
            super.activate();
            ((ObjectModel) getModel()).addPropertyChangeListener(this);
        }
    }

    
    /**
     * 
     * @see org.eclipse.gef.EditPart#deactivate()
     */
    public void deactivate() {
        super.deactivate();
        ((ObjectModel) getModel()).removePropertyChangeListener(this);
    }

    
    /**
     * @param ev event that will be catch by this kind of edit part
     * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
     */
    public void propertyChange(PropertyChangeEvent ev) {
    }

    
    /**
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     */
    public void createEditPolicies() {
    }
}