package org.objectweb.jinha.editpolicies;
 
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;


/**
 * this policy catches requests designed for components and creates commands adapted in output 
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class ComponentEditPolicyForwardDelete extends ComponentEditPolicy
{
	/**
	 * @param request for deleting component
	 * @return the command for deleting
	 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#getDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	protected Command getDeleteCommand(GroupRequest request)
	{
		Command childCommand = createDeleteCommand((GroupRequest) request);
		Command parentCommand = getParentDeleteCommand((GroupRequest) request);
		CompoundCommand com = new CompoundCommand();
		if (childCommand != null)
			com.add(childCommand);
		if (parentCommand != null)
			com.add(parentCommand);

		if (childCommand == null && parentCommand == null)
			return null;
		else
			return com;
	}
	/**
	 * @param request for deleting the parent's component
	 * @return the command for deleting the parent
	 */
	protected Command getParentDeleteCommand(GroupRequest request)
	{
		request.setEditParts(getHost());
		request.setType(RequestConstants.REQ_DELETE_DEPENDANT);
		return getHost().getParent().getCommand(request);
	}
}
