package org.objectweb.jinha.editpolicies;
 
import java.util.Iterator;
import java.util.List;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.eclipse.gef.requests.GroupRequest;

/**
 * this policy catches requests designed for ejb and creates commands in output 
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class EjbComponentEditPolicy extends ComponentEditPolicyForwardDelete
{
	/**
	 * @param r the request for creating the delete command
	 * @return the command
	 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#createDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	public Command createDeleteCommand(GroupRequest r)
	{
		//il faut supprimer les connexions  la classe.
		CompoundCommand com = new CompoundCommand();
		
		List sourceConnections = ((AbstractGraphicalEditPart) getHost()).getSourceConnections();
		Iterator it = sourceConnections.iterator();
		while (it.hasNext())
		{
			GroupRequest request = new GroupRequest();
			request.setType(RequestConstants.REQ_DELETE);
			com.add( ((EditPart)it.next()).getCommand(request) );
		}
		
		List targetConnections = ((AbstractGraphicalEditPart) getHost()).getTargetConnections();
		it = targetConnections.iterator();
		while (it.hasNext())
		{
			GroupRequest request = new GroupRequest();
			request.setType(RequestConstants.REQ_DELETE);
			com.add( ((EditPart)it.next()).getCommand(request) );
		}
		
		if(sourceConnections.size() + targetConnections.size() == 0)
		//une commande compose vide n'est pas excutable or le comportement attendu
		//est qu'elle soit excutable mais ne fasse rien -> retourner null  la place
		//et laisser la mthode getDeleteCommand dcider quoi faire avec ce null.
			return null;
		else
			return com;
	}

}
