package org.objectweb.jinha.editpolicies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ConnectionEditPolicy;
import org.eclipse.gef.requests.GroupRequest;
import org.objectweb.jinha.commands.DeleteRelationCommand;
import org.objectweb.jinha.model.RelationModel;

/**
 * this policy is designed for deleting a relation
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class RelationEditPolicyImpl extends ConnectionEditPolicy
{

	/**
	 * @param request the request for deleting the relation
	 * @return the DeleteRelationCommand
	 * @see org.eclipse.gef.editpolicies.ConnectionEditPolicy#getDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	protected Command getDeleteCommand(GroupRequest request)
	{
		RelationModel connection = (RelationModel)getHost().getModel();
		return new DeleteRelationCommand(connection);
	}
	
}
