package org.objectweb.jinha.editpolicies;

import java.util.Iterator;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gef.requests.GroupRequest;
import org.objectweb.jinha.commands.CreateEjbCommand;
import org.objectweb.jinha.commands.DiagramElementChangeConstraintCommand;
import org.objectweb.jinha.commands.DiagramElementDeleteCommand;
import org.objectweb.jinha.model.DiagramElementModel;
import org.objectweb.jinha.model.DiagramModel;

/**
 * this policy manage the creation, deletion and moving of ejb in the diagram
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class XYLayoutEditPolicyImpl extends XYLayoutEditPolicy
{
	/**
	 * @param child
	 * @param constraint
	 * @return
	 * @see org.eclipse.gef.editpolicies.ConstrainedLayoutEditPolicy#createAddCommand(org.eclipse.gef.EditPart, java.lang.Object)
	 */
	protected Command createAddCommand(EditPart child, Object constraint)
	{
		return null;
	}

	/**
	 * @param child
	 * @param constraint
	 * @return
	 * @see org.eclipse.gef.editpolicies.ConstrainedLayoutEditPolicy#createChangeConstraintCommand(org.eclipse.gef.EditPart, java.lang.Object)
	 */
	protected Command createChangeConstraintCommand(EditPart child, Object constraint)
	{
		Rectangle rect = (Rectangle)constraint;
		DiagramElementModel model = (DiagramElementModel)child.getModel();
		return new DiagramElementChangeConstraintCommand(model, (Rectangle)constraint);
	}

	/**
	 * @param request
	 * @return
	 * @see org.eclipse.gef.editpolicies.LayoutEditPolicy#getCreateCommand(org.eclipse.gef.requests.CreateRequest)
	 */
	protected Command getCreateCommand(CreateRequest request)
	{
		Object newObj = request.getNewObject();
        if(newObj instanceof DiagramElementModel) {
        DiagramElementModel newClass = (DiagramElementModel)newObj;
			DiagramModel diagram = (DiagramModel)getHost().getModel();
			Rectangle rect = (Rectangle)getConstraintFor(request);
			return new CreateEjbCommand(diagram, newClass, rect.getLocation(), rect.getSize());
			//return new CreateEjbCommand(diagram, newClass, request.getLocation(), request.getSize());
        }
		return null;
	}

	/**
	 * @param request
	 * @return
	 * @see org.eclipse.gef.editpolicies.LayoutEditPolicy#getDeleteDependantCommand(org.eclipse.gef.Request)
	 */
	protected Command getDeleteDependantCommand(Request request)
	{
		CompoundCommand cc = new CompoundCommand();
		DiagramModel diagram = (DiagramModel)getHost().getModel();
		Iterator it = ((GroupRequest) request).getEditParts().iterator();
		while(it.hasNext())
		{
			cc.add(
				new DiagramElementDeleteCommand(
					diagram,
					(DiagramElementModel)((EditPart)it.next()).getModel()) );
		}
		return cc;
	}

}
