package org.objectweb.jinha.figures;
 
import java.util.Iterator;
import java.util.List;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.swt.graphics.Image;

public class MethodFigure extends Label {

    private static final Image IMAGE_PUBLIC    = new Image(
                                                       null,
                                                       EjbFigureBorder.class
                                                               .getResourceAsStream("methpub_obj.gif"));

    private static final Image IMAGE_PRIVATE   = new Image(
                                                       null,
                                                       EjbFigureBorder.class
                                                               .getResourceAsStream("methpri_obj.gif"));

    private static final Image IMAGE_PROTECTED = new Image(
                                                       null,
                                                       EjbFigureBorder.class
                                                               .getResourceAsStream("methpro_obj.gif"));

    public static final int    PUBLIC          = 0;

    public static final int    PRIVATE         = 1;

    public static final int    PROTECTED       = 2;

    public void setSignature(String type, String returnType, String identifier,
            List parametersTypes) {
        this.setLabelAlignment(Label.LEFT);
        String txt = returnType + " " + identifier + "(";
        Iterator it = parametersTypes.iterator();
        if (it.hasNext())
            txt += it.next().toString();
        while (it.hasNext()) {
            txt += " ," + it.next().toString();
        }
        txt += ")";
        setText(txt);
        setIcon(getVisibilityIcon(type));
    }

    public Dimension getMinimumSize(int w, int h) {
        return new Dimension(0, 0);
    }

    static public Image getVisibilityIcon(String visibility) {
        if (visibility == "public")
            return IMAGE_PUBLIC;
        if (visibility == "private")
            return IMAGE_PRIVATE;
        if (visibility == "protected")
            return IMAGE_PROTECTED;

        return IMAGE_PUBLIC;
    }

}