
package org.objectweb.jinha.generate;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.internal.resources.File;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.IClasspathEntry;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IPackageFragmentRoot;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.launching.JavaRuntime;
import org.objectweb.jinha.editor.Editor;

import com.objectlearn.jdt.j2ee.core.Bean;
import com.objectlearn.jdt.j2ee.core.EJBModule;
import com.objectlearn.jdt.j2ee.core.Project;
import com.objectlearn.lomboz.xml.lomboz.DocumentRoot;




/**
 * This Class create a Lomboz java project which receive generate Lomboz files (whith
 * Xdoclet tags);
 * project defines 2 folders : the folderOut and the folderIn
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class ProjectJINHa {
    
    IProject project;
    IJavaProject javaProject;
  
    
    void AddBeanXML(String moduleName,List rootObject) {
        // On rcupre le projet courant de Lomboz
        Project lombozProject = null;
        lombozProject = lombozProject.findProject(project);
        
        List containers = lombozProject.getEjbContainers(); //list of EJBModule
        Iterator modules = containers.iterator();
        EJBModule module = null;
        boolean find = false;
        
        while (modules.hasNext() && !find) {
            module = (EJBModule) modules.next();
            if (module.getName().equalsIgnoreCase(moduleName))
                find = true;
        }
        
        if (find) { // on a trouve le module sur lequel on veut ajouter les EJB
            // Ensemble des EJB cre dans JINHa
              
            Bean newBean = new Bean();
            ArrayList newList = new ArrayList();
            
            for(int i=0;i<rootObject.size();i++){  
                if(((DocumentRoot)rootObject.get(i)).getEjb().getEntity()!=null){
                    newBean.setClassName(
                    ((DocumentRoot)rootObject.get(i)).getEjb().getEntity().getEntityEjb().getEjbClass().getUnqualifiedClassName());
                    newBean.setType(1);
                    newList.add(newBean);
                 }
                 
                if(((DocumentRoot)rootObject.get(i)).getEjb().getSession()!=null){
                    newBean.setClassName(
                    ((DocumentRoot)rootObject.get(i)).getEjb().getSession().getSessionEjb().getEjbClass().getUnqualifiedClassName());
                    newBean.setType(0);
                    newList.add(newBean);
                 }
            }
        
        module.saveBeans(newList);

       }
           //lombozProject.updateBeanDefinitions(module);
      }
    
    
    
     
    /**
     * Creation of the project with initialisation of it and his container
     * @param projectName : name of the project we create
     * @return IPackageFragmentRoot : container of the project
     * @throws CoreException
     */
    public IPackageFragmentRoot createSourceFolder(Editor editor, String moduleName) throws CoreException {
            
        project = editor.getFileInput().getProject();
        project.open(null);
        javaProject = JavaCore.create(project);
        IResource resource = javaProject.getCorrespondingResource();
               
        IPackageFragmentRoot[] all = javaProject.getPackageFragmentRoots();
        IPackageFragmentRoot pacRoot = null;
        for (int i = 0; i < all.length; i++) {
            IPackageFragmentRoot root = all[i];
            if (root.getKind() == IPackageFragmentRoot.K_SOURCE &&
            		root.getCorrespondingResource().getProjectRelativePath()
                    .isPrefixOf(resource.getProjectRelativePath())) {
                pacRoot = root;
                return pacRoot;
            }
        }
        if( pacRoot == null)
        {
        	// First look for src, if not found than the last one that is
        	// a source folder
   
            for (int i = 0; i < all.length; i++) {
                IPackageFragmentRoot root = all[i];
                if (root.getKind() == IPackageFragmentRoot.K_SOURCE ){
                	pacRoot = root;
                }
                if(pacRoot != null && "src".equals(pacRoot.getElementName())) {
                    pacRoot = root;
                    return pacRoot;
                }
            }
        }
        return pacRoot;
    }
    
}