package org.objectweb.jinha.model;
 
import java.util.ArrayList;
import java.util.List;
import org.objectweb.jinha.model.emf.jinha.GraphicalEJB;

/**
 * This class send en event when adding or removing objects in it
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class ListModel extends ObjectModel
{
	private List elementList;
    private GraphicalEJB ejb=null;

	public static final String PROPERTY_LIST_MODIFIED = "list modified";

	/**
	 * the default constructor
	 */
	public ListModel()
	{
		elementList = new ArrayList();
	}
	/**
	 * @param element
	 * @param index
	 */
	public void addElement(Object element, int index)
	{
		elementList.add(index, element);
		firePropertyChange(PROPERTY_LIST_MODIFIED, null, null);
	}
	/**
	 * @param element
	 */
	final public void addElement(Object element)
	{
		addElement(element, elementList.size());
	}
	/**
	 * @param element
	 */
	public void removeElement(Object element)
	{
		elementList.remove(element);
		firePropertyChange(PROPERTY_LIST_MODIFIED, null, null);
	}
	/**
	 * @param element
	 * @return
	 */
	public int getIndexOf(Object element)
	{
		return elementList.indexOf(element);
	}
	/**
	 * @return
	 */
	public int getSize()
	{
		return elementList.size();
	}

	/**
	 * @return
	 */
	public List getElementList()
	{
		return elementList;
	}
    /**
     * @return Returns the ejb.
     */
    public GraphicalEJB getEjb() {
        return ejb;
    }
    /**
     * @param ejb The ejb to set.
     */
    public void setEjb(GraphicalEJB ejb) {
        this.ejb = ejb;
    }
}
