package org.objectweb.jinha.model;
 
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import org.objectweb.jinha.model.emf.jinha.GraphicalMessageDriven;
import com.objectlearn.lomboz.xml.lomboz.MessageDrivenBean;


/**
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class MessageDrivenModel extends DiagramElementModel
{
	private BusinessMethodListModel businessMethods;
	private AttributeListModel attributes;
    private HomeMethodListModel homeMethods;
	private String name;

    // Reference vers model EMF SessionBean
    private MessageDrivenBean messageDrivenBean ;
    /*
	private List sourceConnections;
	private List targetConnections;
*/
	private static IPropertyDescriptor[] descriptors;

	public static final String PROPERTY_NAME_CHANGED = "moduleName";
	public static final String PROPERTY_SOURCE_CONNECTIONS_CHANGED = "source connections changed";
	public static final String PROPERTY_TARGET_CONNECTIONS_CHANGED = "target connections changed";

	private static final String ID_PROPERTY_NAME = "moduleName";

	/**
	 * 
	 */
	public MessageDrivenModel()
	{
		businessMethods = new BusinessMethodListModel();
		attributes = new AttributeListModel();
        homeMethods=new HomeMethodListModel();
		/*sourceConnections = new ArrayList();
		targetConnections = new ArrayList();*/
		name = "pas de nom";
		
        
		graphicalEjb = jinhaFactory.createGraphicalMessageDriven();
        MessageDrivenBean messageDrivenBean = ((GraphicalMessageDriven)getGraphicalEjb()).getMessageDrivenBean();
        messageDrivenBean = lombozFactory.createMessageDrivenBean();
        messageDrivenBean.setMessageDrivenEjb(j2eeFactory.createMessageDrivenBeanType());
        messageDrivenBean.getMessageDrivenEjb().setEjbClass(j2eeFactory.createEjbClassType());
        messageDrivenBean.getMessageDrivenEjb().getEjbClass().setValue(name);
        
        setSize(new Dimension(50, 50));
	}

	/**
	 * @return
	 */
	public BusinessMethodListModel getBusinessMethodList()
	{
		return businessMethods;
	}
	/**
	 * @return
	 */
	public AttributeListModel getAttributeList()
	{
		return attributes;
	}
	/**
	 * @param ml
	 */
	public void setMethodList(BusinessMethodListModel ml)
	{
		this.businessMethods = ml;
	}
	/**
	 * @param al
	 */
	public void setAttributeList(AttributeListModel al)
	{
		this.attributes = al;
	}
	/**
	 * @param name
	 */
	public void setName(String name)
	{
		String save = getName();
		this.name = name;
        messageDrivenBean.getMessageDrivenEjb().getEjbClass().setValue(name);
        System.out.println("Le sessionde lomboz est modifie : "+ messageDrivenBean.getMessageDrivenEjb().getEjbClass().getUnqualifiedClassName());
		firePropertyChange(PROPERTY_NAME_CHANGED, save, name);
	}
	/**
	 * @return
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * @return
	 * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyDescriptors()
	 */
	public IPropertyDescriptor[] getPropertyDescriptors()
	{
		if (descriptors == null)
		{
			IPropertyDescriptor[] superDescriptors = super.getPropertyDescriptors();
			descriptors = new IPropertyDescriptor[superDescriptors.length + 1];
			for (int i = 0; i < superDescriptors.length; i++)
				descriptors[i] = superDescriptors[i];
			descriptors[superDescriptors.length] = new TextPropertyDescriptor(ID_PROPERTY_NAME, "moduleName");
		}
		return descriptors;
	}
	/**
	 * @param propName
	 * @param val
	 * @see org.eclipse.ui.views.properties.IPropertySource#setPropertyValue(java.lang.Object, java.lang.Object)
	 */
	public void setPropertyValue(Object propName, Object val)
	{
		if (propName instanceof String && ((String) propName).equals(ID_PROPERTY_NAME))
			setName((String) val);
		else
			super.setPropertyValue(propName, val);
	}
	/**
	 * @param propName
	 * @return
	 * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyValue(java.lang.Object)
	 */
	public Object getPropertyValue(Object propName)
	{
		if (propName instanceof String && ((String) propName).equals(ID_PROPERTY_NAME))
			return getName();
		else
			return super.getPropertyValue(propName);
	}
    /**
     * @return Returns the homeMethods.
     */
    public HomeMethodListModel getHomeMethods() {
        return homeMethods;
    }
    /**
     * @param homeMethods The homeMethods to set.
     */
    public void setHomeMethods(HomeMethodListModel homeMethods) {
        this.homeMethods = homeMethods;
    }
    /**
     * @return
     * @see org.objectweb.jinha.model.DiagramElementModel#getPackageName()
     */
    public String getPackageName() {
        // TODO Auto-generated method stub
        return super.getPackageName();
    }
    /**
     * @param packageName
     * @see org.objectweb.jinha.model.DiagramElementModel#setPackageName(java.lang.String)
     */
    public void setPackageName(String packageName) {
        // TODO Auto-generated method stub
        super.setPackageName(packageName);
        //getSessionBean().getSessionEjb()
        
    }
}
