package org.objectweb.jinha.model;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;



/**
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class ObjectModel implements IPropertySource
{
	protected PropertyChangeSupport listeners;
	protected static IPropertyDescriptor [] descriptors;
	protected ModelCreationFactory factory=new ModelCreationFactory();
    protected Resource res=null;
	public ObjectModel()
	{
		listeners = new PropertyChangeSupport(this);
	}
	
	/**
	 * @param listener
	 */
	public void addPropertyChangeListener(PropertyChangeListener listener)
	{
		listeners.addPropertyChangeListener(listener);
	}
	/**
	 * @param listener
	 */
	public void removePropertyChangeListener(PropertyChangeListener listener)
	{
		listeners.removePropertyChangeListener(listener);
	}
	/**
	 * @param propertyName
	 * @param oldValue
	 * @param newValue
	 */
	protected void firePropertyChange(
		String propertyName,
		Object oldValue,
		Object newValue)
	{
		listeners.firePropertyChange(propertyName, oldValue, newValue);
	}

	/**
	 * @return
	 * @see org.eclipse.ui.views.properties.IPropertySource#getEditableValue()
	 */
	public Object getEditableValue()
	{
		return this;
	}
	/**
	 * @return
	 * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyDescriptors()
	 */
	public IPropertyDescriptor[] getPropertyDescriptors()
	{
		if(descriptors == null)
			descriptors = new IPropertyDescriptor[0];
		return descriptors;
	}
	/**
	 * @param propName
	 * @return
	 * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyValue(java.lang.Object)
	 */
	public Object getPropertyValue(Object propName)
	{
		return null;
	}
	/*final Object getPropertyValue(String propName)
	{
		return null;
	}*/
	/**
	 * @param propName
	 * @return
	 * @see org.eclipse.ui.views.properties.IPropertySource#isPropertySet(java.lang.Object)
	 */
	public boolean isPropertySet(Object propName)
	{
		return true; //isPropertySet((String) propName);
	}
	/*final boolean isPropertySet(String propName)
	{
		return true;
	}*/
	/**
	 * @param propName
	 * @see org.eclipse.ui.views.properties.IPropertySource#resetPropertyValue(java.lang.Object)
	 */
	public void resetPropertyValue(Object propName)
	{
	}
	/**
	 * @param propName
	 * @param val
	 * @see org.eclipse.ui.views.properties.IPropertySource#setPropertyValue(java.lang.Object, java.lang.Object)
	 */
	public void setPropertyValue(Object propName, Object val)
	{
	}
	/*final void setPropertyValue(String propName, Object val)
	{
	}*/
    /**
     * @return Returns the res.
     */
    public Resource getRes() {
        return res;
    }
    /**
     * @param res The res to set.
     */
    public void setRes(Resource res) {
        this.res = res;
    }
}