/**
 * <copyright>
 * </copyright>
 *
 * $Id: JinhaAdapterFactory.java,v 1.1 2004/10/28 16:12:15 camillej Exp $
 */
package org.objectweb.jinha.model.emf.jinha.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.objectweb.jinha.model.emf.jinha.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.objectweb.jinha.model.emf.jinha.JinhaPackage
 * @generated
 */
public class JinhaAdapterFactory extends AdapterFactoryImpl {
    /**
     * The cached model package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static JinhaPackage modelPackage;

    /**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public JinhaAdapterFactory() {
        if (modelPackage == null) {
            modelPackage = JinhaPackage.eINSTANCE;
        }
    }

    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc -->
     * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
     * <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    public boolean isFactoryForType(Object object) {
        if (object == modelPackage) {
            return true;
        }
        if (object instanceof EObject) {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

    /**
     * The switch the delegates to the <code>createXXX</code> methods.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected JinhaSwitch modelSwitch =
        new JinhaSwitch() {
            public Object caseGraphicalEJB(GraphicalEJB object) {
                return createGraphicalEJBAdapter();
            }
            public Object caseGraphicalSession(GraphicalSession object) {
                return createGraphicalSessionAdapter();
            }
            public Object caseGraphicalMessageDriven(GraphicalMessageDriven object) {
                return createGraphicalMessageDrivenAdapter();
            }
            public Object caseGraphicalEntity(GraphicalEntity object) {
                return createGraphicalEntityAdapter();
            }
            public Object caseModuleEjbDefinition(ModuleEjbDefinition object) {
                return createModuleEjbDefinitionAdapter();
            }
            public Object defaultCase(EObject object) {
                return createEObjectAdapter();
            }
        };

    /**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    public Adapter createAdapter(Notifier target) {
        return (Adapter)modelSwitch.doSwitch((EObject)target);
    }


    /**
     * Creates a new adapter for an object of class '{@link org.objectweb.jinha.model.emf.jinha.GraphicalEJB <em>Graphical EJB</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.objectweb.jinha.model.emf.jinha.GraphicalEJB
     * @generated
     */
    public Adapter createGraphicalEJBAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.objectweb.jinha.model.emf.jinha.GraphicalSession <em>Graphical Session</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.objectweb.jinha.model.emf.jinha.GraphicalSession
     * @generated
     */
    public Adapter createGraphicalSessionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.objectweb.jinha.model.emf.jinha.GraphicalMessageDriven <em>Graphical Message Driven</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.objectweb.jinha.model.emf.jinha.GraphicalMessageDriven
     * @generated
     */
    public Adapter createGraphicalMessageDrivenAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.objectweb.jinha.model.emf.jinha.GraphicalEntity <em>Graphical Entity</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.objectweb.jinha.model.emf.jinha.GraphicalEntity
     * @generated
     */
    public Adapter createGraphicalEntityAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.objectweb.jinha.model.emf.jinha.ModuleEjbDefinition <em>Module Ejb Definition</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.objectweb.jinha.model.emf.jinha.ModuleEjbDefinition
     * @generated
     */
    public Adapter createModuleEjbDefinitionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc -->
     * This default implementation returns null.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter() {
        return null;
    }

} //JinhaAdapterFactory
