/**
 * <copyright>
 * </copyright>
 *
 * $Id: JinhaSwitch.java,v 1.1 2004/10/28 16:12:15 camillej Exp $
 */
package org.objectweb.jinha.model.emf.jinha.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.objectweb.jinha.model.emf.jinha.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.objectweb.jinha.model.emf.jinha.JinhaPackage
 * @generated
 */
public class JinhaSwitch {
    /**
     * The cached model package
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static JinhaPackage modelPackage;

    /**
     * Creates an instance of the switch.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public JinhaSwitch() {
        if (modelPackage == null) {
            modelPackage = JinhaPackage.eINSTANCE;
        }
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    public Object doSwitch(EObject theEObject) {
        return doSwitch(theEObject.eClass(), theEObject);
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    protected Object doSwitch(EClass theEClass, EObject theEObject) {
        if (theEClass.eContainer() == modelPackage) {
            return doSwitch(theEClass.getClassifierID(), theEObject);
        }
        else {
            List eSuperTypes = theEClass.getESuperTypes();
            return
                eSuperTypes.isEmpty() ?
                    defaultCase(theEObject) :
                    doSwitch((EClass)eSuperTypes.get(0), theEObject);
        }
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    protected Object doSwitch(int classifierID, EObject theEObject) {
        switch (classifierID) {
            case JinhaPackage.GRAPHICAL_EJB: {
                GraphicalEJB graphicalEJB = (GraphicalEJB)theEObject;
                Object result = caseGraphicalEJB(graphicalEJB);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case JinhaPackage.GRAPHICAL_SESSION: {
                GraphicalSession graphicalSession = (GraphicalSession)theEObject;
                Object result = caseGraphicalSession(graphicalSession);
                if (result == null) result = caseGraphicalEJB(graphicalSession);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case JinhaPackage.GRAPHICAL_MESSAGE_DRIVEN: {
                GraphicalMessageDriven graphicalMessageDriven = (GraphicalMessageDriven)theEObject;
                Object result = caseGraphicalMessageDriven(graphicalMessageDriven);
                if (result == null) result = caseGraphicalEJB(graphicalMessageDriven);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case JinhaPackage.GRAPHICAL_ENTITY: {
                GraphicalEntity graphicalEntity = (GraphicalEntity)theEObject;
                Object result = caseGraphicalEntity(graphicalEntity);
                if (result == null) result = caseGraphicalEJB(graphicalEntity);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case JinhaPackage.MODULE_EJB_DEFINITION: {
                ModuleEjbDefinition moduleEjbDefinition = (ModuleEjbDefinition)theEObject;
                Object result = caseModuleEjbDefinition(moduleEjbDefinition);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            default: return defaultCase(theEObject);
        }
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Graphical EJB</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Graphical EJB</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseGraphicalEJB(GraphicalEJB object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Graphical Session</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Graphical Session</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseGraphicalSession(GraphicalSession object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Graphical Message Driven</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Graphical Message Driven</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseGraphicalMessageDriven(GraphicalMessageDriven object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Graphical Entity</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Graphical Entity</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseGraphicalEntity(GraphicalEntity object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Module Ejb Definition</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Module Ejb Definition</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseModuleEjbDefinition(ModuleEjbDefinition object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch, but this is the last case anyway.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    public Object defaultCase(EObject object) {
        return null;
    }

} //JinhaSwitch
