/*
 * Created on 1 sept. 2004 TODO To change the template for this generated file
 * go to Window - Preferences - Java - Code Style - Code Templates
 */
package org.objectweb.jinha.model.properties;
 
import java.util.List;
import java.util.ListIterator;

import org.eclipse.ui.views.properties.ComboBoxPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.PropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import org.objectweb.jinha.model.CMRModel;
import org.objectweb.jinha.model.EntityModel;
import org.objectweb.jinha.model.ObjectModel;
import org.objectweb.jinha.model.RelationModel;
import org.objectweb.jinha.model.emf.jinha.GraphicalEJB;
import org.objectweb.jinha.model.emf.jinha.GraphicalEntity;

import com.objectlearn.j2ee.gmf.core.EjbConstants;
import com.objectlearn.lomboz.xml.lomboz.EntityBean;

/**
 * @author cressons TODO To change the template for this generated type comment
 *         go to Window - Preferences - Java - Code Style - Code Templates
 */
public class PropertyEjbBeanEntity extends ObjectModel {

    private String              ejbBeanName;

    private String              ejbBeanDisplayName;

    private String              ejbBeanJndiName;

    private String              ejbBeanLocalJndiName;

    private int                 ejbBeanType;

    private int                 ejbBeanViewType;

    public static final String  PROPERTY_NAME_CHANGED                = "name";

    private GraphicalEJB        graphicalEjb;
    
    private EntityModel        entityModel;
    private List relationListTarget;
    private List relationListSource;

    private static final String ID_PROPERTY_EJB_BEAN_NAME            = "ejb.bean name";

    private static final String ID_PROPERTY_EJB_BEAN_DISPLAY_NAME    = "ejb.bean display name";

    private static final String ID_PROPERTY_EJB_BEAN_JNDI_NAME       = "ejb.bean jndi-name";

    private static final String ID_PROPERTY_EJB_BEAN_LOCAL_JNDI_NAME = "ejb.bean local-jndi-name";

    private static final String ID_PROPERTY_EJB_BEAN_TYPE            = "ejb.bean type";

    private static final String ID_PROPERTY_EJB_BEAN_VIEW_TYPE       = "ejb.bean view-type";

    private static final String ID_PROPERTY_EJB_BEAN_CMP_VERSION     = "ejb.bean cmp-version";

    public static final int     CMP                                  = 0;

    public static final int     BMP                                  = 1;

    private String              beanType[]                           = { "CMP",
            "BMP"                                                   };

    public static final int     BOTH                                 = 0;

    public static final int     LOCAL                                = 1;

    public static final int     REMOTE                               = 2;

    private String              viewType[]                           = {
            "Both", "Local", "Remote"                               };

    private IPropertyDescriptor descriptors[];

    /**
     * 
     */
    public PropertyEjbBeanEntity(EntityModel entityModel, String name) {
        descriptors = (new IPropertyDescriptor[] {
                new TextPropertyDescriptor(ID_PROPERTY_EJB_BEAN_NAME, "name"),
                new TextPropertyDescriptor(ID_PROPERTY_EJB_BEAN_DISPLAY_NAME,
                        "display name"),
                new TextPropertyDescriptor(ID_PROPERTY_EJB_BEAN_JNDI_NAME,
                        "jndi-name"),
                new TextPropertyDescriptor(
                        ID_PROPERTY_EJB_BEAN_LOCAL_JNDI_NAME, "local-jndi-name"),

                new ComboBoxPropertyDescriptor(ID_PROPERTY_EJB_BEAN_TYPE,
                        "type", beanType),
                new ComboBoxPropertyDescriptor(ID_PROPERTY_EJB_BEAN_VIEW_TYPE,
                        "view-type", viewType),

                new PropertyDescriptor(ID_PROPERTY_EJB_BEAN_CMP_VERSION,
                        "version-type")

        });
        
        
        relationListTarget = entityModel.getTargetConnections();
        relationListSource = entityModel.getSourceConnections();
        this.graphicalEjb = entityModel.getGraphicalEjb();
        setEjbBeanName(name);
        setEjbBeanDisplayName(name);
        setEjbBeanJndiName(name);
        setEjbBeanLocalJndiName(name);

        ejbBeanType = 0;
        ejbBeanViewType = 0;
    }

    public EntityBean getEntityBean() {
        return ((GraphicalEntity) getGraphicalEjb()).getEntityBean();
    }

    public IPropertyDescriptor[] getPropertyDescriptors() {
        return descriptors;
    }

    public void setPropertyValue(Object propName, Object val) {
        if (propName instanceof String) {
            if (((String) propName).equals(ID_PROPERTY_EJB_BEAN_NAME))
                setEjbBeanName((String) val);
            else if (((String) propName).equals("ejb.bean display name"))
                setEjbBeanDisplayName((String) val);
            else if (((String) propName).equals("ejb.bean jndi-name"))
                setEjbBeanJndiName((String) val);
            else if (((String) propName).equals("ejb.bean local-jndi-name"))
                setEjbBeanLocalJndiName((String) val);
            else if (((String) propName).equals("ejb.bean type")) {

                setEjbBeanType(((Integer) val).intValue());

            }

            else if (((String) propName).equals("ejb.bean view-type")) {

                setEjbBeanViewType(((Integer) val).intValue());
            }

        }
        else {
            super.setPropertyValue(propName, val);
        }
    }

    public Object getPropertyValue(Object propName) {
        if (propName instanceof String) {
            if (((String) propName).equals("ejb.bean name"))
                return getEjbBeanName();
            if (((String) propName).equals("ejb.bean display name"))
                return getEjbBeanDisplayName();
            if (((String) propName).equals("ejb.bean jndi-name"))
                return getEjbBeanJndiName();
            if (((String) propName).equals("ejb.bean local-jndi-name"))
                return getEjbBeanLocalJndiName();
            if (((String) propName).equals("ejb.bean type")) {
                return new Integer(getEjbBeanType());

            }
            if (((String) propName).equals("ejb.bean view-type"))
                return new Integer(getEjbBeanViewType());
            if (((String) propName).equals(ID_PROPERTY_EJB_BEAN_CMP_VERSION))
                return EjbConstants.LABEL_BEAN_ENTITY_VERSION2;
            else
                return super.getPropertyValue(propName);
        }
        else {
            return super.getPropertyValue(propName);
        }
    }

    public String getEjbBeanDisplayName() {
        return ejbBeanDisplayName;
    }

    public String getEjbBeanJndiName() {
        return ejbBeanJndiName;
    }

    public String getEjbBeanLocalJndiName() {
        return ejbBeanLocalJndiName;
    }

    public String getEjbBeanName() {
        return ejbBeanName;
    }

    public void setEjbBeanDisplayName(String ejbBeanDisplayName) {
        String save = getEjbBeanDisplayName();
        this.ejbBeanDisplayName = ejbBeanDisplayName;
        
        
    }

    public void setEjbBeanJndiName(String ejbBeanJndiName) {
        String save = getEjbBeanJndiName();
        this.ejbBeanJndiName = ejbBeanJndiName;
        getEntityBean().getEntityEjb().getEjbName().setValue(ejbBeanJndiName);
    }

    public void setEjbBeanLocalJndiName(String ejbBeanLocalJndiName) {
        String save = getEjbBeanLocalJndiName();
        this.ejbBeanLocalJndiName = ejbBeanLocalJndiName;
        
        
    }

    public void setEjbBeanName(String ejbBeanName) {
        String save = getEjbBeanName();
        this.ejbBeanName = ejbBeanName;
        //TODO set the Unqualified class Name to interact with the name of the
        // EJB
        getEntityBean().getEntityEjb().getEjbClass().setValue(getEntityBean().getEntityEjb().getEjbClass().getPackageName()+"."+getEjbBeanName());
              
        // Mise a jour des references dans les CMR externes 

        refreshCmrName(save);
        
        // Envoie pour la mise a jour graphique
        firePropertyChange(PROPERTY_NAME_CHANGED, save, ejbBeanName);
    }

    public void setEjbBeanType(int ejbBeanType) {
        if (ejbBeanType >= 0 && ejbBeanType < beanType.length) {
            this.ejbBeanType = ejbBeanType;

            //getEntityBean().getEntityEjb().getEjbName().get;
        }
    }

    public GraphicalEJB getGraphicalEjb() {
        return graphicalEjb;
    }

    public void setGraphicalEjb(GraphicalEJB graphicalEjb) {
        this.graphicalEjb = graphicalEjb;
    }

    public String toString() {
        return "to customize the ejb.bean part for XDoclet";
    }

    public int getEjbBeanType() {
        return ejbBeanType;
    }

    public int getEjbBeanViewType() {
        return ejbBeanViewType;
    }

    public void setEjbBeanViewType(int ejbBeanViewType) {
        if (ejbBeanType >= 0 && ejbBeanType < beanType.length) {
            this.ejbBeanViewType = ejbBeanViewType;
            //TODO Ajout EMF pour le view-type d'un EJB Bean

           
        }
    }

    public void refreshCmrName(String oldName){
        
        // Refresh from target list
        ListIterator listIt =relationListTarget.listIterator();
        //Iterator it = list.iterator();
        while(listIt.hasNext()){
            // CMR src
            RelationModel relation = (RelationModel)listIt.next();
            CMRModel cmrModel = relation.getCMRsrc();
            if(cmrModel != null && cmrModel.getIdentifier().substring(3).compareTo(oldName) == 0){
                if( cmrModel.getMultiplicity().compareTo("one") == 0)
                {
                    cmrModel.setReturnType(ejbBeanName);
                }
                cmrModel.setIdentifier("get"+ejbBeanName);
           }
            
            // CMR Target
            CMRModel cmrModelTarget = relation.getCMRtarget();
            if(cmrModelTarget != null && cmrModelTarget.getIdentifier().substring(3).compareTo(oldName) == 0){
                if( cmrModelTarget.getMultiplicity().compareTo("one") == 0)
                {
                    cmrModelTarget.setReturnType(ejbBeanName);
                }
                cmrModelTarget.setIdentifier("get"+ejbBeanName);
           }
            
        }
        
        // Refresh from source list
        listIt =relationListSource.listIterator();
        //Iterator it = list.iterator();
        while(listIt.hasNext()){
            // CMR Src
            RelationModel relation = (RelationModel)listIt.next();
            CMRModel cmrModel = relation.getCMRsrc();
            if(cmrModel != null && cmrModel.getIdentifier().substring(3).compareTo(oldName) == 0){
                if( cmrModel.getMultiplicity().compareTo("one") == 0)
                {
                    cmrModel.setReturnType(ejbBeanName);
                }
                cmrModel.setIdentifier("get"+ejbBeanName);
           }
            
            // CMR Target
            CMRModel cmrModelTarget = relation.getCMRtarget();
            if(cmrModelTarget != null && cmrModelTarget.getIdentifier().substring(3).compareTo(oldName) == 0){
                if( cmrModelTarget.getMultiplicity().compareTo("one") == 0)
                {
                    cmrModelTarget.setReturnType(ejbBeanName);
                }
                cmrModelTarget.setIdentifier("get"+ejbBeanName);
           }
        }
        
        
    }
}