package org.objectweb.jinha.model.properties;
 
import org.eclipse.ui.views.properties.ComboBoxPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import org.objectweb.jinha.model.ObjectModel;
import org.objectweb.jinha.model.emf.jinha.GraphicalEJB;
import org.objectweb.jinha.model.emf.jinha.GraphicalSession;

import com.objectlearn.lomboz.xml.lomboz.SessionBean;

// Referenced classes of package org.objectweb.jinha.model:
//            ObjectModel

public class PropertyEjbBeanSession extends ObjectModel {

    private String              ejbBeanName;

    private String              ejbBeanDisplayName;

    private String              ejbBeanJndiName;

    private String              ejbBeanLocalJndiName;

    //private String ejbBeanTransactionType;

    private int                 ejbBeanType;

    private int                 ejbBeanTransactionType;

    private int                 ejbBeanViewType;

    private GraphicalEJB        graphicalEjb;

    private final String        defaultValue                          = "no name";

    public static final String  PROPERTY_NAME_CHANGED                 = "name";

    private static final String ID_PROPERTY_EJB_BEAN_NAME             = "ejb.bean name";

    private static final String ID_PROPERTY_EJB_BEAN_DISPLAY_NAME     = "ejb.bean display name";

    private static final String ID_PROPERTY_EJB_BEAN_JNDI_NAME        = "ejb.bean jndi-name";

    private static final String ID_PROPERTY_EJB_BEAN_LOCAL_JNDI_NAME  = "ejb.bean local-jndi-name";

    private static final String ID_PROPERTY_EJB_BEAN_TYPE             = "ejb.bean type";

    private static final String ID_PROPERTY_EJB_BEAN_TRANSACTION_TYPE = "ejb.bean transaction-type";

    private static final String ID_PROPERTY_EJB_BEAN_VIEW_TYPE        = "ejb.bean view-type";

    private static final int    CONTAINER                             = 0;

    private static final int    BEAN                                  = 1;

    private String              beanTransactionType[]                 = {
            "Container", "Bean"                                      };

    public static final int     STATELESS                             = 0;

    public static final int     STATEFULL                             = 1;

    private String              beanType[]                            = {
            "Stateless", "Stateful"                                 };

    public static final int     BOTH                                  = 0;

    public static final int     LOCAL                                 = 1;

    public static final int     REMOTE                                = 2;

    private String              viewType[]                            = {
            "both", "local", "remote"                                };

    private IPropertyDescriptor descriptors[];

    public PropertyEjbBeanSession(GraphicalEJB graphicalEjb, String name) {
        descriptors = (new IPropertyDescriptor[] {
                new TextPropertyDescriptor(ID_PROPERTY_EJB_BEAN_NAME, "name"),
                new TextPropertyDescriptor(ID_PROPERTY_EJB_BEAN_DISPLAY_NAME,
                        "display name"),
                new TextPropertyDescriptor(ID_PROPERTY_EJB_BEAN_JNDI_NAME,
                        "jndi-name"),
                new TextPropertyDescriptor(
                        ID_PROPERTY_EJB_BEAN_LOCAL_JNDI_NAME, "local-jndi-name"),
                new ComboBoxPropertyDescriptor(ID_PROPERTY_EJB_BEAN_TYPE,
                        "type", beanType),
                new ComboBoxPropertyDescriptor(
                        ID_PROPERTY_EJB_BEAN_TRANSACTION_TYPE,
                        "transaction-type", beanTransactionType),
                new ComboBoxPropertyDescriptor(ID_PROPERTY_EJB_BEAN_VIEW_TYPE,
                        "view-type", viewType)

        });
        this.graphicalEjb = graphicalEjb;
        setEjbBeanName(name);
        setEjbBeanDisplayName(name);
        setEjbBeanJndiName(name);
        setEjbBeanLocalJndiName(name);
        setEjbBeanType(0);
        setEjbBeanTransactionType(0);
        setEjbBeanViewType(0);

    }

    public SessionBean getSessionBean() {
        return ((GraphicalSession) getGraphicalEjb()).getSessionBean();
    }

    public IPropertyDescriptor[] getPropertyDescriptors() {

        // TODO add descriptor for view-Type, get and set propertyValue , and
        // getter and setter ... with EMF link
        //}
        return descriptors;
    }

    public void setPropertyValue(Object propName, Object val) {
        if (propName instanceof String) {
            if (((String) propName).equals("ejb.bean name"))
                setEjbBeanName((String) val);
            else if (((String) propName).equals("ejb.bean display name"))
                setEjbBeanDisplayName((String) val);
            else if (((String) propName).equals("ejb.bean jndi-name"))
                setEjbBeanJndiName((String) val);
            else if (((String) propName).equals("ejb.bean local-jndi-name"))
                setEjbBeanLocalJndiName((String) val);
            else if (((String) propName).equals("ejb.bean type")) {
                setEjbBeanType(((Integer) val).intValue());
                //                            
            }
            else if (((String) propName).equals("ejb.bean transaction-type"))
                setEjbBeanTransactionType(((Integer) val).intValue());

            else if (((String) propName).equals("ejb.bean view-type")) {

                setEjbBeanViewType(((Integer) val).intValue());
                //                    if(((Integer)val).intValue() == 0)
                //                        setEjbBeanType(0);
                //                    else
                //                        if(((Integer)val).intValue() == 1)
                //                            setEjbBeanType(1);
            }

        }
        else {
            super.setPropertyValue(propName, val);
        }
    }

    public Object getPropertyValue(Object propName) {
        if (propName instanceof String) {
            if (((String) propName).equals("ejb.bean name"))
                return getEjbBeanName();
            if (((String) propName).equals("ejb.bean display name"))
                return getEjbBeanDisplayName();
            if (((String) propName).equals("ejb.bean jndi-name"))
                return getEjbBeanJndiName();
            if (((String) propName).equals("ejb.bean local-jndi-name"))
                return getEjbBeanLocalJndiName();
            if (((String) propName).equals("ejb.bean type")) {
                return new Integer(getEjbBeanType());

            }
            if (((String) propName).equals("ejb.bean transaction-type"))
                return new Integer(getEjbBeanTransactionType());
            if (((String) propName).equals("ejb.bean view-type"))
                return new Integer(getEjbBeanViewType());
            else
                return super.getPropertyValue(propName);
        }
        else {
            return super.getPropertyValue(propName);
        }
    }

    public String getEjbBeanDisplayName() {
        return ejbBeanDisplayName;
    }

    public String getEjbBeanJndiName() {
        return ejbBeanJndiName;
    }

    public String getEjbBeanLocalJndiName() {
        return ejbBeanLocalJndiName;
    }

    public int getEjbBeanTransactionType() {
        return ejbBeanTransactionType;
    }

    public String getEjbBeanName() {
        return ejbBeanName;
    }

    public void setEjbBeanDisplayName(String ejbBeanDisplayName) {
        String save = getEjbBeanDisplayName();
        this.ejbBeanDisplayName = ejbBeanDisplayName;
    }

    public void setEjbBeanJndiName(String ejbBeanJndiName) {
        String save = getEjbBeanJndiName();
        this.ejbBeanJndiName = ejbBeanJndiName;
        getSessionBean().getSessionEjb().getEjbName().setValue(ejbBeanJndiName);
    }

    public void setEjbBeanLocalJndiName(String ejbBeanLocalJndiName) {
        String save = getEjbBeanLocalJndiName();
        this.ejbBeanLocalJndiName = ejbBeanLocalJndiName;
    }

    public void setEjbBeanName(String ejbBeanName) {
        String save = getEjbBeanName();
        this.ejbBeanName = ejbBeanName;
        getSessionBean().getSessionEjb().getEjbClass().setValue(getSessionBean().getSessionEjb().getEjbClass().getPackageName()+"."+getEjbBeanName());
       /* String unqualifiedClassName = getSessionBean().getSessionEjb()
                .getEjbClass().getUnqualifiedClassName();
        unqualifiedClassName = ejbBeanName;*/
       
        firePropertyChange(PROPERTY_NAME_CHANGED, save, ejbBeanName);
    }

    public void setEjbBeanTransactionType(int ejbBeanTransactionType) {
        if (ejbBeanTransactionType >= 0
                && ejbBeanTransactionType < beanTransactionType.length) {
            this.ejbBeanTransactionType = ejbBeanTransactionType;
            //getSessionBean().getSessionEjb().getSessionType().setValue(beanTransactionType[ejbBeanTransactionType]);
            getSessionBean().getSessionEjb().getTransactionType().setValue(
                    beanTransactionType[ejbBeanTransactionType]);
        }
    }

    public void setEjbBeanType(int ejbBeanType) {
        if (ejbBeanType >= 0 && ejbBeanType < beanType.length) {
            this.ejbBeanType = ejbBeanType;
            getSessionBean().getSessionEjb().getSessionType().setValue(
                    beanType[ejbBeanType]);
        }
    }

    public GraphicalEJB getGraphicalEjb() {
        return graphicalEjb;
    }

    public void setGraphicalEjb(GraphicalEJB graphicalEjb) {
        this.graphicalEjb = graphicalEjb;
    }

    public String toString() {
        return "to customize the ejb.bean part for XDoclet";
    }

    public int getEjbBeanType() {
        return ejbBeanType;
    }

    public int getEjbBeanViewType() {
        return ejbBeanViewType;
    }

    public void setEjbBeanViewType(int ejbBeanViewType) {
        if (ejbBeanType >= 0 && ejbBeanType < beanType.length) {
            this.ejbBeanViewType = ejbBeanViewType;
            //TODO Ajout EMF pour le view-type d'un EJB Bean

        }
    }
}