package org.objectweb.jinha.model.properties;

import org.eclipse.ui.views.properties.ComboBoxPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import org.objectweb.jinha.model.ObjectModel;
import org.objectweb.jinha.model.emf.jinha.GraphicalEJB;
import org.objectweb.jinha.model.emf.jinha.GraphicalSession;

import com.objectlearn.lomboz.xml.lomboz.SessionBean;
 
public class PropertyEjbRefSession extends ObjectModel {

    private String              ejbRefEjbName;

    private String              ejbRefRefName;

    private int                 ejbRefViewType;

    public static final int     REMOTE                        = 0;

    public static final int     LOCAL                         = 1;

    private String              viewType[]                    = { "remote",
            "local"                                          };

    private final String        defaultValue                  = "no name";

    private GraphicalEJB        graphicalEjb;

    private static final String ID_PROPERTY_EJB_REF_EJB_NAME  = "ejb:ejb-ref ejb-name";

    private static final String ID_PROPERTY_EJB_REF_REF_NAME  = "ejb:ejb-ref ref-name";

    private static final String ID_PROPERTY_EJB_REF_VIEW_TYPE = "ejb:ejb-ref view-type";

    private IPropertyDescriptor descriptors[]                 = {
            new TextPropertyDescriptor(ID_PROPERTY_EJB_REF_EJB_NAME,
                    "ejb:ejb-ref ejb-name"),
            new ComboBoxPropertyDescriptor(ID_PROPERTY_EJB_REF_VIEW_TYPE,
                    "ejb:ejb-ref view-type", viewType),
            new TextPropertyDescriptor(ID_PROPERTY_EJB_REF_REF_NAME,
                    "ejb:ejb-ref ref-name")                  };

    public PropertyEjbRefSession(GraphicalEJB graphicalEjb) {
        this.graphicalEjb = graphicalEjb;
        ejbRefEjbName = defaultValue;
        ejbRefRefName = defaultValue;

        ejbRefViewType = 0;
    }

    public SessionBean getSessionBean() {
        return ((GraphicalSession) getGraphicalEjb()).getSessionBean();
    }

    public IPropertyDescriptor[] getPropertyDescriptors() {
        return descriptors;
    }

    public void setPropertyValue(Object propName, Object val) {
        if (propName instanceof String) {
            if (((String) propName).equals(ID_PROPERTY_EJB_REF_EJB_NAME))
                setEjbRefEjbName((String) val);
            else if (((String) propName).equals("ejb:ejb-ref ref-name"))
                setEjbRefRefName((String) val);
            else if (((String) propName).equals("ejb:ejb-ref view-type")) {
                //setEjbRefViewType((String)val);
                setEjbRefViewType(((Integer) val).intValue());
            }
        }
        else {
            super.setPropertyValue(propName, val);
        }
    }

    public Object getPropertyValue(Object propName) {
        if (propName instanceof String) {
            if (((String) propName).equals(ID_PROPERTY_EJB_REF_EJB_NAME))
                return getEjbRefEjbName();
            if (((String) propName).equals("ejb:ejb-ref ref-name"))
                return getEjbRefRefName();
            if (((String) propName).equals("ejb:ejb-ref view-type"))
                return new Integer(getEjbRefViewType());
            else
                return super.getPropertyValue(propName);
        }
        else {
            return super.getPropertyValue(propName);
        }
    }

    public GraphicalEJB getGraphicalEjb() {
        return graphicalEjb;
    }

    public void setGraphicalEjb(GraphicalEJB graphicalEjb) {
        this.graphicalEjb = graphicalEjb;
    }

    public String getEjbRefEjbName() {
        return ejbRefEjbName;
    }

    public void setEjbRefEjbName(String ejbRefEjbName) {
        String save = getEjbRefEjbName();
        this.ejbRefEjbName = ejbRefEjbName;
    }

    public String getEjbRefRefName() {
        return ejbRefRefName;
    }

    public void setEjbRefRefName(String ejbRefRefName) {
        String save = getEjbRefRefName();
        this.ejbRefRefName = ejbRefRefName;
    }

    public int getEjbRefViewType() {
        return ejbRefViewType;
    }

    public void setEjbRefViewType(int ejbRefViewType) {
        this.ejbRefViewType = ejbRefViewType;
        // TODO EMF part to complete !!
        //(GraphicalSession)getGraphicalEjb()).getSessionBean().getSessionEjb().getEjbRef()

    }

    public String toString() {

        return "to customize the ejb.ref part for XDoclet";
    }
}