package org.objectweb.jinha.testing.junit;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.List;

import junit.framework.TestCase;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.objectweb.jinha.model.emf.jinha.JinhaFactory;
import org.objectweb.jinha.model.emf.jinha.JinhaPackage;

import com.objectlearn.lomboz.xml.lomboz.DocumentRoot;
import com.objectlearn.lomboz.xml.lomboz.LombozFactory;
import com.objectlearn.lomboz.xml.lomboz.LombozPackage;
import com.objectlearn.lomboz.xml.lomboz.util.LombozResourceFactoryImpl;
import com.sun.java.xml.ns.j2ee.J2eeFactory;
import com.sun.java.xml.ns.j2ee.J2eePackage;



/**
 * this class is used for testing the serialization of the Lomboz EMF model
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 */
public class testSerialization extends TestCase {
	
	protected JinhaPackage jinhaPackage = JinhaPackage.eINSTANCE;

    protected JinhaFactory jinhaFactory = jinhaPackage.getJinhaFactory();

    protected J2eePackage j2eePackage = J2eePackage.eINSTANCE;

    protected J2eeFactory j2eeFactory = j2eePackage.getJ2eeFactory();

    protected LombozPackage lombozPackage = LombozPackage.eINSTANCE;

    protected LombozFactory lombozFactory = lombozPackage.getLombozFactory();
    
    
    /**
     * this function test the serialization of an instance of an EML model
     * it creates an XML file with the serialization of the instance 
     * then regenerate the model in java interface from the file 
     * @param rootObject : list of DocumentRoot to serialized
     */
    void Test(List rootObject){
    
    	for(int i=0;i<rootObject.size();i++){
    		
    		String serialization = ((DocumentRoot)rootObject.get(i)).toString();
    		DocumentRoot o = lombozFactory.createDocumentRoot();
	
    		try {
    			LombozResourceFactoryImpl lombozResourceFactoryImpl = new LombozResourceFactoryImpl();

    			Resource resource = lombozResourceFactoryImpl.createResource(URI
    					.createPlatformResourceURI("testSerialization.JINHa"));
    			ByteArrayInputStream inputStream = new ByteArrayInputStream(
    					serialization.getBytes());
    			resource.load(inputStream, null);
    			o = (DocumentRoot) resource.getContents().get(0);
    			rootObject.remove(i);
    			rootObject.add(i,o);
    		}catch (IOException e4){
    			e4.printStackTrace();
    		}
    	}
    }
}
	
	